/*
* Copyright 2021 E.J.I.E., S.A.
*
* Licencia con arreglo a la EUPL, Versión 1.1 exclusivamente (la «Licencia»);
* Solo podrá usarse esta obra si se respeta la Licencia.
* Puede obtenerse una copia de la Licencia en
*
* http://ec.europa.eu/idabc/eupl.html
*
* Salvo cuando lo exija la legislación aplicable o se acuerde por escrito,
* el programa distribuido con arreglo a la Licencia se distribuye «TAL CUAL»,
* SIN GARANT�?AS NI CONDICIONES DE NINGÚN TIPO, ni expresas ni implícitas.
* Véase la Licencia en el idioma concreto que rige los permisos y limitaciones
* que establece la Licencia.
*/
package com.ejie.ad74a.control;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.propertyeditors.CustomDateEditor;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.ServletRequestDataBinder;
import org.springframework.web.bind.annotation.InitBinder;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.multipart.support.ByteArrayMultipartFileEditor;

import com.ejie.ad74a.model.ConvivientesInfSoci;
import com.ejie.ad74a.service.ConvivientesInfSociService;
import com.ejie.ad74a.util.comun.UtilSeguridad;
import com.ejie.ad74a.util.constantes.Constantes;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.util.DateTimeManager;

/**
 * ConvivientesInfSociController generated by UDA, 07-sep-2023 11:42:27.
 * 
 * @author UDA
 */
@Controller
@RequestMapping(value = "/convivientesinfsoci")
public class ConvivientesInfSociController {
	private static final Logger logger = LoggerFactory.getLogger(ConvivientesInfSociController.class);

	@Autowired
	private ConvivientesInfSociService convivientesInfSociService;

	@InitBinder
	protected void initBinder(HttpServletRequest request, ServletRequestDataBinder binder) throws ServletException {
		binder.registerCustomEditor(byte[].class, new ByteArrayMultipartFileEditor());
		binder.registerCustomEditor(Date.class,
				new CustomDateEditor(DateTimeManager.getDateTimeFormat(LocaleContextHolder.getLocale()), true));
	}

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 */

	/**
	 * Operación CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idConviviente82 Long
	 *
	 * @return ConvivientesInfSoci Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idConviviente82}", method = RequestMethod.GET)
	public @ResponseBody ConvivientesInfSoci get(@PathVariable Long idConviviente82) {
		ConvivientesInfSoci convivientesInfSoci = new ConvivientesInfSoci();
		convivientesInfSoci.setIdConviviente82(idConviviente82);
		convivientesInfSoci = this.convivientesInfSociService.find(convivientesInfSoci);
		ConvivientesInfSociController.logger.info("[GET - findBy_PK] : Obtener ConvivientesInfSoci por PK");
		return convivientesInfSoci;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parámetro.
	 *
	 * @param filterConvivientesInfSoci Objeto ConvivientesInfSoci que contiene los
	 *                                  parámetros de filtrado utilizados en la
	 *                                  búsqueda.
	 *
	 * @return List<ConvivientesInfSoci> Lista de objetos correspondientes a la
	 *         búsqueda realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<ConvivientesInfSoci> getAll(
			@ModelAttribute ConvivientesInfSoci filterConvivientesInfSoci) {
		ConvivientesInfSociController.logger.info("[GET - find_ALL] : Obtener ConvivientesInfSoci por filtro");
		return this.convivientesInfSociService.findAll(filterConvivientesInfSoci, null);
	}

	/**
	 * Operación CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param convivientesInfSoci Bean ConvivientesInfSoci que contiene la
	 *                            informacion a modificar.
	 *
	 * @return ConvivientesInfSoci Bean resultante de la modificacion.
	 */
	@RequestMapping(value = "/edit", method = RequestMethod.PUT)
	public @ResponseBody ConvivientesInfSoci edit(@RequestBody ConvivientesInfSoci convivientesInfSoci) {
		ConvivientesInfSoci convivientesInfSociAux = this.convivientesInfSociService.update(convivientesInfSoci);
		ConvivientesInfSociController.logger.info("[PUT] : ConvivientesInfSoci actualizado correctamente");
		return convivientesInfSociAux;
	}

	@RequestMapping(value = "/{idInfSocial82}/edit", method = RequestMethod.PUT)
	public @ResponseBody ConvivientesInfSoci customEdit(@PathVariable Long idInfSocial82,
			@RequestBody ConvivientesInfSoci convivientesInfSoci, HttpServletRequest request) {

		// ConvivientesInfSoci convivientesInfSoci = new ConvivientesInfSoci();
		if (idInfSocial82 != null && idInfSocial82.compareTo(0L) == 0) {
			// Tenemos que borrarlo de la sesión

			HttpSession sesion = request.getSession();
			List<ConvivientesInfSoci> convivientes = new ArrayList<ConvivientesInfSoci>();
			if (sesion.getAttribute(Constantes.VARCONTEXTO_CONVIVIENTES) != null) {
				convivientes = (List<ConvivientesInfSoci>) sesion.getAttribute(Constantes.VARCONTEXTO_CONVIVIENTES);
			}

			// Buscar el conviviente a modificar
			for (int i = 0; i < convivientes.size(); i++) {
				ConvivientesInfSoci conv = convivientes.get(i);
				if (conv.getIdConviviente82().compareTo(convivientesInfSoci.getIdConviviente82()) == 0) {
					convivientes.set(i, convivientesInfSoci);
					break;
				}
			}

			sesion.setAttribute(Constantes.VARCONTEXTO_CONVIVIENTES, convivientes);
			ConvivientesInfSociController.logger
					.info("[POST] : ConvivientesInfSoci actualizado correctamente en sesión");

		} else {
			convivientesInfSoci = this.convivientesInfSociService.update(convivientesInfSoci);
			ConvivientesInfSociController.logger.info("[PUT] : ConvivientesInfSoci actualizado correctamente");
		}

		return convivientesInfSoci;

	}

	/**
	 * Operación CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param convivientesInfSoci Bean ConvivientesInfSoci que contiene la
	 *                            informacion con la que se va a crear el nuevo
	 *                            registro.
	 *
	 * @return ConvivientesInfSoci Bean resultante del proceso de creacion.
	 */
	@RequestMapping(value = "/add", method = RequestMethod.POST)
	public @ResponseBody ConvivientesInfSoci add(@RequestBody ConvivientesInfSoci convivientesInfSoci) {
		convivientesInfSoci.setUsuAlta82(UtilSeguridad.getNameUsuarioConectado());
		ConvivientesInfSoci convivientesInfSociAux = this.convivientesInfSociService.add(convivientesInfSoci);
		ConvivientesInfSociController.logger.info("[POST] : ConvivientesInfSoci insertado correctamente");
		return convivientesInfSociAux;
	}

	@RequestMapping(value = "/{idInfSocial82}/add", method = RequestMethod.POST)
	public @ResponseBody ConvivientesInfSoci customAdd(@PathVariable Long idInfSocial82,
			@RequestBody ConvivientesInfSoci convivientesInfSoci, HttpServletRequest request) {

		ConvivientesInfSoci convivientesInfSociAux;
		if (idInfSocial82 != null && idInfSocial82.compareTo(0L) == 0) {
			// Tenemos que guardarlo en la sesión
//			convivientesInfSoci.setIdInfSocial82(idInfSocial82);
//			convivientesInfSociAux = this.convivientesInfSociService.add(convivientesInfSoci);
			HttpSession sesion = request.getSession();
			List<ConvivientesInfSoci> convivientes = new ArrayList<ConvivientesInfSoci>();
			if (sesion.getAttribute(Constantes.VARCONTEXTO_CONVIVIENTES) != null) {
				convivientes = (List<ConvivientesInfSoci>) sesion.getAttribute(Constantes.VARCONTEXTO_CONVIVIENTES);
			}

			// Creamos un id temporal para el conviviente
			convivientesInfSoci.setIdConviviente82(Long.valueOf(convivientes.size() + 1));
			convivientes.add(convivientesInfSoci);

			sesion.setAttribute(Constantes.VARCONTEXTO_CONVIVIENTES, convivientes);
			ConvivientesInfSociController.logger.info("[POST] : ConvivientesInfSoci insertado correctamente en sesión");
			return convivientesInfSoci;

		} else {
			convivientesInfSoci.setIdInfSocial82(idInfSocial82);
			convivientesInfSoci.setUsuAlta82(UtilSeguridad.getNameUsuarioConectado());
			convivientesInfSociAux = this.convivientesInfSociService.add(convivientesInfSoci);
			ConvivientesInfSociController.logger.info("[POST] : ConvivientesInfSoci insertado correctamente");
			return convivientesInfSociAux;
		}

	}

	/**
	 * Operación CRUD Delete. Borrado del registro correspondiente a partir del
	 * identificador especificado.
	 *
	 * @param idConviviente82 Long Identificador del objeto que se desea eliminar.
	 *
	 * @return ConvivientesInfSoci Bean eliminado.
	 */
	@RequestMapping(value = "/{idConviviente82}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody ConvivientesInfSoci delete(@PathVariable Long idConviviente82) {
		ConvivientesInfSoci convivientesInfSoci = new ConvivientesInfSoci();
		convivientesInfSoci.setIdConviviente82(idConviviente82);
		this.convivientesInfSociService.remove(convivientesInfSoci);
		ConvivientesInfSociController.logger.info("[DELETE] : ConvivientesInfSoci borrado correctamente");
		return convivientesInfSoci;
	}

	@RequestMapping(value = "/{idInfSocial82}/{idConviviente82}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody ConvivientesInfSoci customDelete(@PathVariable Long idInfSocial82,
			@PathVariable Long idConviviente82, HttpServletRequest request) {

		ConvivientesInfSoci convivientesInfSoci = new ConvivientesInfSoci();
		if (idInfSocial82 != null && idInfSocial82.compareTo(0L) == 0) {
			// Tenemos que borrarlo de la sesión

			HttpSession sesion = request.getSession();
			List<ConvivientesInfSoci> convivientes = new ArrayList<ConvivientesInfSoci>();
			if (sesion.getAttribute(Constantes.VARCONTEXTO_CONVIVIENTES) != null) {
				convivientes = (List<ConvivientesInfSoci>) sesion.getAttribute(Constantes.VARCONTEXTO_CONVIVIENTES);
			}

			// Buscar el conviviente a borrar
			for (int i = 0; i < convivientes.size(); i++) {
				ConvivientesInfSoci conv = convivientes.get(i);
				if (conv.getIdConviviente82().compareTo(idConviviente82) == 0) {
					convivientes.remove(i);
					break;
				}
			}

			sesion.setAttribute(Constantes.VARCONTEXTO_CONVIVIENTES, convivientes);
			ConvivientesInfSociController.logger.info("[POST] : ConvivientesInfSoci borrado correctamente de sesión");

		} else {
			convivientesInfSoci.setIdConviviente82(idConviviente82);
			this.convivientesInfSociService.remove(convivientesInfSoci);
			ConvivientesInfSociController.logger.info("[DELETE] : ConvivientesInfSoci borrado correctamente");
		}

		return convivientesInfSoci;
	}

	/*
	 * MÉTODOS COMPONENTE RUP_TABLE
	 */

	/**
	 * Método de presentación del RUP_TABLE.
	 * 
	 * @param model Model
	 *
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getMaint(Model model) {
		ConvivientesInfSociController.logger.info("[GET - View] : convivientesinfsoci");
		model.addAttribute("convivientesinfsoci", new ConvivientesInfSoci());
		return "convivientesinfsoci";
	}

	/**
	 * Obtener el formulario de edición.
	 * 
	 * @param actionType   String
	 * @param fixedMessage String
	 * @param model        Model
	 *
	 * @return String
	 */
	@RequestMapping(value = "/editForm", method = RequestMethod.POST)
	public String getEditForm(@RequestParam(required = true) String actionType,
			@RequestParam(required = false) String fixedMessage, Model model) {
		ConvivientesInfSociController.logger.info("[POST - editForm] : convivientesinfsoci");

		model.addAttribute("convivientesinfsoci", new ConvivientesInfSoci());
		model.addAttribute("actionType", actionType);

		if (fixedMessage != null) {
			model.addAttribute("fixedMessage", fixedMessage);
		}

		return "convivientesinfsociEditForm";
	}

	/**
	 * Obtener el formulario necesario para permitir el uso de la edición en línea.
	 * 
	 * @param actionType String
	 * @param tableID    String
	 * @param mapping    String
	 * @param model      Model
	 *
	 * @return String
	 */
	@RequestMapping(value = "/inlineEdit", method = RequestMethod.POST)
	public String getInlineEditForm(@RequestParam(required = true) String actionType,
			@RequestParam(required = true) String tableID, @RequestParam(required = false) String mapping,
			Model model) {
		ConvivientesInfSociController.logger.info("[POST - inlineEditForm] : convivientesinfsoci");

		model.addAttribute("entity", new ConvivientesInfSoci());
		model.addAttribute("actionType", actionType);
		model.addAttribute("tableID", tableID);

		// Controlar que el mapping siempre se añada al modelo de la manera esperada
		if (mapping == null || mapping.isEmpty()) {
			mapping = "/convivientesinfsoci";
		} else if (mapping.endsWith("/")) {
			mapping = mapping.substring(0, mapping.length() - 1);
		}
		model.addAttribute("mapping", mapping);

		return "convivientesinfsociInlineEditAuxForm";
	}

	@RequestMapping(value = "/clear", method = RequestMethod.GET)
	public @ResponseBody List<ConvivientesInfSoci> clearSession(HttpServletRequest request) {
		ConvivientesInfSociController.logger.info("[GET - View] : clear session");
		HttpSession sesion = request.getSession();
		sesion.setAttribute(Constantes.VARCONTEXTO_CONVIVIENTES, new ArrayList<ConvivientesInfSoci>());

		return new ArrayList<ConvivientesInfSoci>();

	}

	/**
	 * Operación de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterConvivientesInfSoci Bean ConvivientesInfSoci que contiene los
	 *                                  parámetros de filtrado a emplear.
	 * @param tableRequestDto           Dto que contiene los parámetros de
	 *                                  configuración propios del RUP_TABLE a
	 *                                  aplicar en el filtrado.
	 *
	 * @return TableResourceResponseDto<ConvivientesInfSoci> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<ConvivientesInfSoci> filter(
			@RequestJsonBody(param = "filter") ConvivientesInfSoci filterConvivientesInfSoci,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request) {

		ConvivientesInfSociController.logger.info("[POST - filter] : Obtener ConvivientesInfSocis");
		return this.convivientesInfSociService.filter(filterConvivientesInfSoci, tableRequestDto, false);
	}

	@RequestMapping(value = "/{idInfSocial82}/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<ConvivientesInfSoci> customFilter(@PathVariable Long idInfSocial82,
			@RequestJsonBody(param = "filter") ConvivientesInfSoci filterConvivientesInfSoci,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request) {

		ConvivientesInfSociController.logger.info("[POST - customFilter] : Obtener ConvivientesInfSocis");

		if (idInfSocial82 != null && idInfSocial82.compareTo(0L) == 0) {
			// Tenemos que obtenerlo de la sesión
//			filterConvivientesInfSoci.setIdInfSocial82(idInfSocial82);
//			return this.convivientesInfSociService.filter(filterConvivientesInfSoci, tableRequestDto, false);
			HttpSession sesion = request.getSession();
			List<ConvivientesInfSoci> convivientes = new ArrayList<ConvivientesInfSoci>();
			if (sesion.getAttribute(Constantes.VARCONTEXTO_CONVIVIENTES) != null) {
				convivientes = (List<ConvivientesInfSoci>) sesion.getAttribute(Constantes.VARCONTEXTO_CONVIVIENTES);
			}

			Long recordNum = Long.valueOf(convivientes.size());
			TableResponseDto<ConvivientesInfSoci> tableResponseDto = new TableResponseDto<ConvivientesInfSoci>(
					tableRequestDto, recordNum, convivientes);
			return tableResponseDto;

		} else {
			filterConvivientesInfSoci.setIdInfSocial82(idInfSocial82);
			return this.convivientesInfSociService.filter(filterConvivientesInfSoci, tableRequestDto, false);
		}

	}

	/**
	 * Operación de búsqueda del componente RUP_TABLE.
	 * 
	 * @param filterConvivientesInfSoci Bean ConvivientesInfSoci que contiene los
	 *                                  parámetros de filtrado a emplear.
	 * @param searchConvivientesInfSoci Bean ConvivientesInfSoci que contiene los
	 *                                  parámetros de búsqueda a emplear.
	 * @param tableRequestDto           Dto que contiene los parámetros de
	 *                                  configuración propios del RUP_TABLE a
	 *                                  aplicar en la búsqueda.
	 *
	 * @return TableRowDto<ConvivientesInfSoci> Dto que contiene el resultado de la
	 *         búsqueda realizada por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/search", method = RequestMethod.POST)
	public @ResponseBody List<TableRowDto<ConvivientesInfSoci>> search(
			@RequestJsonBody(param = "filter") ConvivientesInfSoci filterConvivientesInfSoci,
			@RequestJsonBody(param = "search") ConvivientesInfSoci searchConvivientesInfSoci,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ConvivientesInfSociController.logger.info("[POST - search] : Buscar ConvivientesInfSocis");
		return this.convivientesInfSociService.search(filterConvivientesInfSoci, searchConvivientesInfSoci,
				tableRequestDto, false);
	}

	/**
	 * Borrado múltiple de registros
	 * 
	 * @param filterConvivientesInfSoci Bean ConvivientesInfSoci que contiene los
	 *                                  parámetros de filtrado a emplear.
	 * @param tableRequestDto           Dto que contiene los parámetros de
	 *                                  configuración propios del RUP_TABLE a
	 *                                  aplicar en la búsqueda.
	 *
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> deleteMultiple(TableRequestDto tableRequestDto) {
		ConvivientesInfSociController.logger.info("[POST - deleteMultiple] : Eliminar multiples ConvivientesInfSocis");
		this.convivientesInfSociService.removeMultiple(tableRequestDto);
		ConvivientesInfSociController.logger.info("All entities correctly deleted!");

		return tableRequestDto.getMultiselection().getSelectedIds();
	}

	/**
	 * EXPORTERS
	 */

	/**
	 * Devuelve los datos exportados de la tabla y los copia al portapapeles.
	 *
	 * @param filterConvivientesInfSoci ConvivientesInfSoci
	 * @param columns                   String[]
	 * @param columnsName               String[]
	 * @param reportsParams             ArrayList<?>
	 * @param tableRequestDto           TableRequestDto
	 */
	@RequestMapping(value = "/clipboardReport", method = RequestMethod.POST)
	public @ResponseBody List<ConvivientesInfSoci> getClipboardReport(
			@RequestJsonBody(param = "filter") ConvivientesInfSoci filterConvivientesInfSoci,
			@RequestParam(required = false) String[] columns, @RequestParam(required = false) String[] columnsName,
			@RequestParam(required = false) ArrayList<?> reportsParams,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ConvivientesInfSociController.logger.info("[POST - clipboardReport] : : Copiar en Portapapeles");
		return this.convivientesInfSociService.getDataForReports(filterConvivientesInfSoci, tableRequestDto);
	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filter          ConvivientesInfSoci
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param reportsParams   ArrayList<?>
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = { "/xlsReport",
			"/xlsxReport" }, method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	public @ResponseBody void generateExcelReport(
			@RequestJsonBody(param = "filter", required = false) ConvivientesInfSoci filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody(param = "reportsParams", required = false) ArrayList<?> reportsParams,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		ConvivientesInfSociController.logger.info("[POST - generateExcelReport] : Devuelve un fichero excel");
		this.convivientesInfSociService.generateReport(filter, columns, columnsName, fileName, sheetTitle,
				reportsParams, tableRequestDto, request, response);
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filter          ConvivientesInfSoci
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param reportsParams   ArrayList<?>
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "pdfReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	public @ResponseBody void generatePDFReport(
			@RequestJsonBody(param = "filter", required = false) ConvivientesInfSoci filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody(param = "reportsParams", required = false) ArrayList<?> reportsParams,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		ConvivientesInfSociController.logger.info("[POST - generatePDFReport] : Devuelve un fichero pdf");
		this.convivientesInfSociService.generateReport(filter, columns, columnsName, fileName, sheetTitle,
				reportsParams, tableRequestDto, request, response);
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filter          ConvivientesInfSoci
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param reportsParams   ArrayList<?>
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "odsReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	public @ResponseBody void generateODSReport(
			@RequestJsonBody(param = "filter", required = false) ConvivientesInfSoci filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody(param = "reportsParams", required = false) ArrayList<?> reportsParams,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		ConvivientesInfSociController.logger.info("[POST - generateODSReport] : Devuelve un fichero ods");
		this.convivientesInfSociService.generateReport(filter, columns, columnsName, fileName, sheetTitle,
				reportsParams, tableRequestDto, request, response);
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filter          ConvivientesInfSoci
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param reportsParams   ArrayList<?>
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "csvReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	public @ResponseBody void generateCSVReport(
			@RequestJsonBody(param = "filter", required = false) ConvivientesInfSoci filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody(param = "reportsParams", required = false) ArrayList<?> reportsParams,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		ConvivientesInfSociController.logger.info("[POST - generateCSVReport] : Devuelve un fichero csv");
		this.convivientesInfSociService.generateReport(filter, columns, columnsName, fileName, sheetTitle,
				reportsParams, tableRequestDto, request, response);
	}
}
